package com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.model.global.standardJBIClassImplementation;

import it.eng.utils.PropertyModel;

import java.util.ArrayList;
import java.util.List;

import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.NameSpaceClass;


/**
 * The Splitter Service mix model.
 * @author Cedric Mouilleron
 * @author Pierre Notel
 *@author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class DroolsSemanticValidatorClass extends StandardJBIClass implements IServiceEngineClass {

	/**the target name.*/
	private String targetName = "";
	/**The target namespace.*/
	private NameSpaceClass targetNamespace = null;
	/**Drl file resource.*/
	private String rulebaseResource = "";



	/**
	 * @param serviceNameParam : the service name.
	 * @param serviceNamespaceParam : the namespace using by this service.
	 * @param endpointValueParam : the endpoint value.
	 * @param jbiNms : the jbi namespace.
	 * @param targetNameParam : the target name.
	 * @param targetNamespaceParam : the namespace using by the target.
	 * @param pathRuleParam : the xpath rule using by this component.
	 */
	public DroolsSemanticValidatorClass(final String serviceNameParam,
			final NameSpaceClass serviceNamespaceParam,
			final String endpointValueParam,
			final NameSpaceClass jbiNms,
			final String targetNameParam,
			final NameSpaceClass targetNamespaceParam,
			final String rulebaseResource) {
		super(jbiNms);
		this.serviceName = serviceNameParam;
		this.serviceNamespace = serviceNamespaceParam;
		this.endpointValue = endpointValueParam;
		this.targetName = targetNameParam;
		this.targetNamespace = targetNamespaceParam;
		this.rulebaseResource =	rulebaseResource;
	}


	


	/**
	 * @return the serviceName
	 */
	public final String getServiceName() {
		return serviceName;
	}


	


	/**
	 * @return the targetName
	 */
	public final String getTargetName() {
		return targetName;
	}


	


	/**
	 * @return the targetNamespace
	 */
	public final NameSpaceClass getTargetNamespace() {
		return targetNamespace;
	}


	public String getRulebaseResource() {
		return rulebaseResource;
	}


	public void setRulebaseResource(String rulebaseResource) {
		this.rulebaseResource = rulebaseResource;
	}

	@Override
	public List<PropertyModel> getPropertiesToStore() {
		
		List<PropertyModel> propertiesToStore = new ArrayList<PropertyModel>();
		propertiesToStore.add(createPropertyModel("rulebaseResource",rulebaseResource));
		return propertiesToStore;
	}
}
