package com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.model.global.standardJBIClassImplementation;

import it.eng.utils.PropertyModel;

import java.util.ArrayList;
import java.util.List;

import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.NameSpaceClass;

/**
 * The Aggregator Service mix model.
 * @author Cedric Mouilleron
 * @author Pierre Notel
 *@author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class StandardEIPAggregator extends StandardJBIClass implements IServiceEngineClass {

	/**the target name.*/
	private String targetName = "";
	/**The target namespace.*/
	private NameSpaceClass targetNamespace = null;

	private String aggregateEnvelopeName = null;
	private String messageEnvelopeName = null;

	/**
	 * @param serviceNameParam : the service name.
	 * @param serviceNamespaceParam : the namespace using by this service.
	 * @param endpointValueParam : the endpoint service value.
	 * @param jbiNms : the jbi namespace.
	 * @param targetNameParam : the target name.
	 * @param targetNamespaceParam : the target namespace.
	 */
	public StandardEIPAggregator(final String serviceNameParam,
			final NameSpaceClass serviceNamespaceParam,
			final String endpointValueParam,
			final NameSpaceClass jbiNms,
			final String targetNameParam,
			final NameSpaceClass targetNamespaceParam,
			final String aggregateEnvelopeNameParam,
			final String messageEnvelopeNameParam) {
		super(jbiNms);
		this.serviceName = serviceNameParam;
		this.serviceNamespace = serviceNamespaceParam;
		this.endpointValue = endpointValueParam;
		this.targetName = targetNameParam;
		this.targetNamespace = targetNamespaceParam;
		this.aggregateEnvelopeName = aggregateEnvelopeNameParam;
		this.messageEnvelopeName = messageEnvelopeNameParam;
	}


	


	/**
	 * @return the serviceName
	 */
	public final String getServiceName() {
		return serviceName;
	}


	


	/**
	 * @return the targetName
	 */
	public final String getTargetName() {
		return targetName;
	}


	/**
	 * @return the targetNamespace
	 */
	public final NameSpaceClass getTargetNamespace() {
		return targetNamespace;
	}


	public String getAggregateEnvelopeName() {
		return aggregateEnvelopeName;
	}


	public String getMessageEnvelopeName() {
		return messageEnvelopeName;
	}
	
	@Override
	public List<PropertyModel> getPropertiesToStore() {
		
		List<PropertyModel> propertiesToStore = new ArrayList<PropertyModel>();
		propertiesToStore.add(createPropertyModel("aggregateEnvelopeName",aggregateEnvelopeName));
		propertiesToStore.add(createPropertyModel("messageEnvelopeName",messageEnvelopeName));
		
		return propertiesToStore;
	}


}
