package com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.model.standardModel;

/**
 * This class reprensents the Service Unit in the standard
 * ServiceMix model.
 * @author Cedric MOUILLERON
 * @author Pierre NOTEL
 *@author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class ServiceUnitClass {
	/**the name of this SU.*/
	private String suName = "";
	/**The description of this SU.*/
	private String suDescription = "";
	/**the name of the artifact.*/
	private String suArtifact = "";
	/**The component name .*/
	private String suComponentName = "";
	/**boolean to determine if the component is JBI or not.*/
	private boolean isStandard = false;
	/**Reference to a standard compoennt.*/
	private StandardJBIJARClass monStandard = null;
	/**Reference to a StandardLWComponentClass.*/
	private StandardLWComponentClass monLW = null;

	/**
	 * the constructor with parameter.
	 * @param name ; the name
	 * @param description : the description
	 * @param suArti : the artifact name
	 * @param suCompoName : the su component name.
	 */
	public ServiceUnitClass(final String name, final String
			description, final String suArti, final String suCompoName) {
		super();
		this.suName = name;
		this.suArtifact = suArti;
		this.suComponentName = suCompoName;
		this.suDescription = description;
	}
	/**
	 * @return Returns the suArtifact.
	 */
	public final String getSuArtifact() {
		return suArtifact;
	}
	/**
	 * @return Returns the suComponentName.
	 */
	public final String getSuComponentName() {
		return suComponentName;
	}
	/**
	 * @return Returns the suDescription.
	 */
	public final String getSuDescription() {
		return suDescription;
	}
	/**
	 * @return Returns the suName.
	 */
	public final String getSuName() {
		return suName;
	}
	/**
	 * @return Returns the monLW.
	 */
	public final  StandardLWComponentClass getLW() {
		return monLW;
	}
	/**
	 * @param monLWP The monLW to set.
	 */
	public final void addLW(final StandardLWComponentClass monLWP) {
		if (monLWP != null) {
			this.isStandard = false;
			monLW = monLWP;
		}
	}

	/**
	 * @return Returns the monStandard.
	 */
	public final StandardJBIJARClass getMonStandard() {
		return monStandard;
	}

	/**
	 * @param monStandardP The monStandard to set.
	 */
	public final void setMonStandard(final
			StandardJBIJARClass monStandardP) {
		if (monStandardP != null) {
			this.isStandard = true;
			this.monStandard = monStandardP;
		}
	}

	/**
	 * @return Returns the isStandard.
	 */
	public final boolean isStandard() {
		return isStandard;
	}



}
